function Results=parkingOptimization(IniAdjoint)

global T N m b g x0 dx0 xf dxf
       
if nargin<1
    IniAdjoint=rand(1,2);
end
   

options = optimset('GradObj','off','Display','iter', ...
                   'TolX',1e-6,'TolCon',1e-6,'TolFun',1e-6,'maxiter',1000, ...
                   'MaxFunEvals',10000,'NonlEqnAlgorithm','lm','Algorithm','trust-region-reflective'); % 

[res,fval,exitflag,output,jacobian]=fsolve(@(z) parkingOptimizationShootingCost(z),IniAdjoint,options);


%% COMPUTE THE OPTIMAL SOLUTION
iniAdjoint=res ;
IniState=[ x0 dx0 iniAdjoint ];
times=linspace(0,T,N)';
options = odeset('RelTol',1e-4,'AbsTol',1e-4);
[tmp,Sol] = ode45(@(t,x) parkingOptimizationSystemDiff(t,x), times, IniState, options);

x=Sol(:,1);
dx=Sol(:,2);

p1=Sol(:,3);
p2=Sol(:,4);

Results.CoState=[p1 p2];
Results.State = [x dx];
Results.Time = times;
