function dX = parkingOptimizationSystemDiff(t,X)

global T N m b g x0 dx0 xf dxf 
    
X1   = X(1);
X2  = X(2);

p1  = X(3);
p2  = X(4);

% The maximisation of the Hamiltonian leads to: u1=-r1=tau1dot and
% u2=-r2=tau2dot

% Initialization
dX = zeros(4,1); 
    
% dynamical system
dX(1) = X2;
dX(2) = -(1/m^2) * p2 - b/m*X2 - 2/m * atan(X1) / (1 + X1^2);
dX(3) =  (2/m) * p2 * (1 - 2 * X1 * atan(X1))/(1 + X1^2)^2 ;
dX(4) = -p1 + b/m * p2;
   

